unit Unit1;

(*
{$H-}
{$ALIGN OFF}
type
  TIdentInfo  = packed record
                  IdentCode   : String[13];   // 0
                  BName       : String[20];   // 14
                  AknPort     : Word;         // 34
                  BufSize     : Word;         // 36
                  Stackversion: Word;         // 38
                  CompileDate : String[10];   // 40
                  CompileTime : String[5];    // 50
                  CompilerRev : Word;         // 55
                  FirmWare    : String[20];   // 57
                  xUDP        : boolean;      // 77
                  SourceIP    : string[16];
                  SourcePort  : word;
                end;

  tMailInfo  = packed record
                 MailServer    : string[16];
                 Port          : word;
                 Sender        : string[32];
                 Recipient     : string[32];
                 CC            : string[32];
                 BCC           : string[32];
                 UserID        : string[16];
                 ReplyTo       : string[16];
                 Subject       : string[16];
                 Result        : tMapError;
               end;

  tFTPcmd    = (FTPChangeDir, FTPChangeDirUp, FTPDelete, FTPMakeDir, FTPRemoveDir,
                FTPRename, FTPSendFile, FTPFileAppend, FTPGetFile, FTPGetBlock,
                FTPMakeFile, FTPListFiles, FTPFileSize, FTPGetDir);

  TFTPInfo   = packed record
                 Username     : string[20];
                 Password     : string[20];
                 FTPServer    : string[15];
                 Port         : word;
                 Filename     : string[32];
                 Filename1    : string[32];
                 TransfBinary : boolean;
                 FilePointer  : integer;
                 BlockSize    : word;
                 FTPcmd       : tFTPcmd;
                 Result       : tMapError;
               end;

  tFileCmd   = (FileChangeDir, FileChangeDirUp, FileDelete, FileMakeDir, FileRemoveDir,
                FileRename, FileSendFile, FileFileAppend, FileGetFile, FileGetBlock,
                FileMakeFile, FileListFiles, FileFileSize, FileGetDir);

  TFILEInfo  = packed record
                 Filename     : string[32];
                 Filename1    : string[32];
                 FilePointer  : integer;
                 BlockSize    : word;
                 FILEcmd      : tFileCmd;
                 Result       : tMapError;
               end;

  tTelnetcmd  = (tnLogin, tnCMD, tnLogout);
  tTelnetInfo = packed record
                  TelnetCMD    : tTelnetcmd;
                  Result       : tMapError;
                end;

  TChatInfo  = packed record
                 Username     : string[20];
                 Password     : string[20];
                 Server       : string[15];
                 Port         : word;
                 Filename     : string[32];
                 Transfertype : byte;
                 Buffer       : word;
                 CmdCode      : byte;
                 Result       : tMapError;
               end;

  THTTPInfo  = packed record
                 Username     : string[20];
                 Password     : string[20];
                 Server       : string[15];
                 Port         : word;
                 Filename     : string[32];
                 Transfertype : byte;
                 Buffer       : word;
                 CmdCode      : byte;
                 Result        : tMapError;
               end;


  tMapRec    = packed record
                 IdentType : tIdentType;
                 case integer of
                   0 : (IdentInfo    : TIdentInfo);
                   1 : (TxMailInfo   : tMailInfo);
                   2 : (TxFTPInfo    : TFTPInfo);
                   3 : (TxTELNETInfo : TTELNETInfo);
                   4 : (TxChatInfo   : TChatInfo);
                   5 : (TxHTTPInfo   : THTTPInfo);
                   6 : (TxFILEInfo   : TFILEInfo);
                   7 : (RxMailInfo   : tMailInfo);
                   8 : (buffer       : array[0..1536] of byte);
               end;

  txUDPdata  = array[0..1536] of byte;

{$ALIGN ON}
{$H+}
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, eUDP,
  WSocket, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    xUDPserver: TxUDPserver;
    xUDPclient: TxUDPclient;
    Button1: TButton;
    CountPanel: TPanel;
    Label1: TLabel;
    ClearBtn: TBitBtn;
    StringPanel: TPanel;
    ShowCheck: TCheckBox;
    UDPbtn: TSpeedButton;
    xUDPbtn: TSpeedButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure xUDPserverDataAvail(Sender: TObject; Data: txUDPdata;
      count: Integer; SenderIP, SenderPort: String);
    procedure ClearBtnClick(Sender: TObject);
    procedure ShowCheckClick(Sender: TObject);
    procedure UDPbtnClick(Sender: TObject);
    procedure xUDPbtnClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
//  packet    :   tMapRec;
  packcount : integer;

procedure TForm1.FormCreate(Sender: TObject);
begin
  xUDPserver.active:= true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var buffer : txUDPdata;
    st     : string[32];
    idx    : integer;
    count  : integer;
begin
  xUDPclient.TargetIP:= '192.168.1.16';
  xUDPclient.TargetPort:= '8090';
  if xUDPbtn.down then begin
    xUDPclient.UDPmode:= xUDPmode;
  end
  else begin
    xUDPclient.UDPmode:= UDPmode;
  end;
//  if xUDPclient.SendUDPpacket(packet, xxx) then begin

  st:= 'Hello test';
  count:= length(st)+1;
  for idx:= 0 to count do begin
    buffer[idx]:= byte(st[idx]);
  end;
  if xUDPclient.SendUDPdata(buffer, count) then begin
    Beep;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var buffer : txUDPdata;
    st     : string[32];
    idx    : integer;
    count  : integer;
begin
  xUDPclient.TargetIP:= '192.168.1.16';
  xUDPclient.TargetPort:= '137';
  if xUDPbtn.down then begin
    xUDPclient.UDPmode:= xUDPmode;
  end
  else begin
    xUDPclient.UDPmode:= UDPmode;
  end;
//  if xUDPclient.SendUDPpacket(packet, xxx) then begin

  st:= 'Hello test';
  count:= length(st)+1;
  for idx:= 0 to count do begin
    buffer[idx]:= byte(st[idx]);
  end;
  if xUDPclient.SendUDPdata(buffer, count) then begin
    Beep;
  end;
end;

// the followowing event has to be used if pure xUDP data is expected
procedure TForm1.xUDPserverDataAvail(Sender: TObject; Data: txUDPdata;
  count: Integer; SenderIP, SenderPort: String);
var st     : string;
    idx    : integer;
begin
  //  Beep;
  inc(packcount);
  CountPanel.caption:= IntToStr(packcount);
  if ShowCheck.checked then begin
    // because we receive a string from our test NetStack
    // we display it here
    st:= '';
    for idx:= 0 to count-1 do begin
      st:= st+char(data[idx]);
    end;
    StringPanel.caption:= st;
  end;
end;

// the followowing event has to be used if xUDP packets are expected
// which contain Packets in the mapper style
{
procedure TForm1.xUDPserverPacketAvail(Sender: TObject; xPacket: tMapRec; SenderIP, SenderPort: String);
begin
  Beep;
  if SenderIP <> '' then;
  if SenderPort <> '' then;
  case xPacket.IdentType of
    idxRequMapper  : begin
                       // not used here
                     end;
    idxFTP         : begin
                       // not used here
                     end;
    idxEmail       : begin
                       // not used here
                     end;
    idxTelNet      : begin
                       // not used here
                     end;
    idxChat        : begin
                       // not used here
                     end;
    idxHTTP        : begin
                       // not used here
                     end;
    idxFile        : begin
                       // not used here
                     end;
    idxPeer        : begin
                       // not used here
                     end;
  end;
end;
}

procedure TForm1.ClearBtnClick(Sender: TObject);
begin
  xUDPserver.active:= false;
  xUDPserver.active:= true;
  packcount:= 0;
  CountPanel.caption:= '0';
  StringPanel.caption:= '';
end;

procedure TForm1.ShowCheckClick(Sender: TObject);
begin
  CountPanel.caption:= IntToStr(packcount);
end;

procedure TForm1.UDPbtnClick(Sender: TObject);
begin
  xUDPserver.active:= false;
  xUDPserver.UDPmode:= UDPmode;
  xUDPserver.active:= true;
end;

procedure TForm1.xUDPbtnClick(Sender: TObject);
begin
  xUDPserver.active:= false;
  xUDPserver.UDPmode:= xUDPmode;
  xUDPserver.active:= true;
end;

initialization
finalization
end.



